% *************************************************************************
% 
%                      iGem Modelling - 2016
%                     Delft University of Technology
% 
% *************************************************************************
% 
%               Title
% 
%                    File: Growth trate
%                           Model:Determining growth rate from OD values 
% 
%              
% *************************************************************************
clear all;close all
%% read excel file
OD_GFP_Fit_platereader          = xlsread('20161001_fluorkinet_MV.xlsx',1,'B75:CE138');
OD_blank    = OD_GFP_Fit_platereader(1:4,:);
OD_GFP_data = OD_GFP_Fit_platereader([5:8 25:28 15:18 45:48 35:38 39:42 59:62 49:52 13:14 23:24 55:58],:);
OD_mVe_data = OD_GFP_Fit_platereader([29:32 53:54 63:64],:);
OD_mCe_data = OD_GFP_Fit_platereader([9:12 19:22 33:34 43:44],:);
% order GFP: 100, 108, 105, 117, 113

em_GFP       = xlsread('20161001_fluorkinet_MV.xlsx',1,'B142:CE207');
em_GFP_blank = em_GFP(3:6,:);
em_GFP_data  = em_GFP([5:8 25:28 15:18 45:48 35:38 39:42 59:62 49:52 13:14 23:24 55:58]+2,:);
time         = em_GFP(1,:);

em_mVe       = xlsread('20161001_fluorkinet_MV.xlsx',1,'B211:CE276');
em_mVe_data  = em_mVe([29:32 53:54 63:64]+2,:);
em_mVe_blank = em_mVe(3:6,:);

em_mCe       = xlsread('20161001_fluorkinet_MV.xlsx',1,'B280:CE345');
em_mCe_data  = em_mCe([9:12 19:22 33:34 43:44]+2,:);
em_mCe_blank = em_mCe(3:6,:);
time_hr = time./3600;
%% subtract blank OD from samples OD
OD_blank_mean = zeros(1,size(OD_blank,2));
for ii = 1:size(OD_blank,2)
    OD_blank_mean(ii) = mean(OD_blank(:,ii));
end
OD_GFP_norm = OD_GFP_data - ones(size(OD_GFP_data,1),1)*OD_blank_mean;
OD_mVe_norm = OD_mVe_data - ones(size(OD_mVe_data,1),1)*OD_blank_mean;
OD_mCe_norm = OD_mCe_data - ones(size(OD_mCe_data,1),1)*OD_blank_mean;
%% subtract blank emission from sample emission
em_GFP_blank_mean = zeros(1,size(em_GFP_blank,2));
for i = 1:size(em_GFP_blank,2)
    em_GFP_blank_mean(i) = nanmean(em_GFP_blank(:,i),1);
end
em_GFP_norm = em_GFP_data - ones(size(em_GFP_data,1),1)*em_GFP_blank_mean;

em_mVe_blank_mean = zeros(1,size(em_mVe_blank,2));
for i = 1:size(em_mVe_blank,2)
    em_mVe_blank_mean(i) = nanmean(em_mVe_blank(:,i));
end
em_mVe_norm = em_mVe_data - ones(size(em_mVe_data,1),1)*em_mVe_blank_mean;

em_mCe_blank_mean = zeros(1,size(em_mCe_blank,2));
for i = 1:size(em_mCe_blank,2)
    em_mCe_blank_mean(i) = nanmean(em_mCe_blank(:,i));
end
em_mCe_norm = em_mCe_data - ones(size(em_mCe_data,1),1)*em_mCe_blank_mean;



%% Mean OD values
for ii = 1:10
    OD_GFP_mean(ii,:)= nanmean(OD_GFP_norm(ii*4-3:ii*4,:),1);
    em_GFP_mean(ii,:)= nanmean(em_GFP_norm(ii*4-3:ii*4,:),1);
end

for ii = 1:2
   OD_mVe_mean(ii,:) = nanmean(OD_mVe_norm(ii*4-3:ii*4,:),1);
   em_mVe_mean(ii,:) = nanmean(em_mVe_norm(ii*4-3:ii*4,:),1);
end

for ii = 1:3
    OD_mCe_mean(ii,:) = nanmean(OD_mCe_norm(ii*4-3:ii*4,:),1);
    em_mCe_mean(ii,:) = nanmean(em_mCe_norm(ii*4-3:ii*4,:),1);
end
%%
% *************************************************************************
%                           Emission/OD
% *************************************************************************

%% divide emission by OD
em_GFP_OD = em_GFP_norm./OD_GFP_norm;
em_mVe_OD = em_mVe_norm./OD_mVe_norm;
em_mCe_OD = em_mCe_norm./OD_mCe_norm;
em_mCe_OD(4,:)=0; %em_mCe_norm(4,:)./OD_mCe_Fit(1,:);

%%

% *************************************************************************
%                           GROWTH RATE FIT
% *************************************************************************
%           	****************************************
%                                 GFP
%           	****************************************

%%
Tf = 55;
Tfp=82;
close all
 figure('units','normalized','outerposition',[0 0 1 1])
 promoters = ['J23100';'J23108';'J23105';'J23117';'J23113';'      ';'      ';'      ';'      ';'      ']
for ii=1:length(OD_GFP_mean(:,1))/2
    Fitv_GFP(ii,1) = OD_GFP_mean(ii,1); % OD(
    [Fitv_GFP(ii,2:4)]=growthrate(time_hr(1:Tf),OD_GFP_mean(ii,1:Tf), [0.96,1,0.2],Fitv_GFP(ii,1)); % Fit values mu_max, OD_max, q

    OD_GFP_Fit (ii,:)          = Fitv_GFP(ii,3)*Fitv_GFP(ii,1).*(Fitv_GFP(ii,4).*exp(Fitv_GFP(ii,2)*time_hr)+1)...
                  ./(Fitv_GFP(ii,1)*Fitv_GFP(ii,4).*(exp(Fitv_GFP(ii,2)*time_hr)-1)+Fitv_GFP(ii,3)*(Fitv_GFP(ii,4)+1));    % Fitted N(t)

    if ii>=6
        subplot(1,5,ii-5)
        hold on 
      
        plot(time_hr(1:Tfp),OD_GFP_Fit(ii,1:Tfp)','LineWidth',1.5, 'r')
        plot(time_hr,OD_GFP_mean(ii,:),'b','LineWidth',3 )
         hold off
    else 
        subplot(1,5,ii)
        hold on 
       
        plot(time_hr(1:Tfp),OD_GFP_Fit(ii,1:Tfp),'r','LineWidth',3)
         plot(time_hr,OD_GFP_mean(ii,:),'o','MarkerSize',2,'LineWidth',1)
         hold off
        title(promoters(ii,:))
    end
     

     if ii==1
        ylabel('OD')
     end
     if ii==3
         xlabel('time[h]')
     end
ax = gca;
ax.LineWidth = 3;
ax.FontSize = 18;
  mut_GFP(ii,:) = Fitv_GFP(ii,4)*Fitv_GFP(ii,2)./(Fitv_GFP(ii,4)+exp(-Fitv_GFP(ii,2).*time_hr)).*(Fitv_GFP(ii,3)-Fitv_GFP(ii,1))*(1+Fitv_GFP(ii,4))./(Fitv_GFP(ii,1).*(1+Fitv_GFP(ii,4).*exp(Fitv_GFP(ii,2).*time_hr))+(Fitv_GFP(ii,3)-Fitv_GFP(ii,1))*(1+Fitv_GFP(ii,4)));
end
%%
 figure('units','normalized','outerposition',[0 0 1 1])
    hold on 
    p1=plot(time_hr,em_GFP_mean(1:5,:), 'LineWidth',2)
    legend(promoters)
    ax = gca;
    ax.LineWidth = 2;
	ax.FontSize = 18;
    xlabel('time(h)')
    ylabel('Fluorescence (a.u.)')
%     end
%%
Tfp=82
 figure('units','normalized','outerposition',[0 0 1 1])
 for ii=1:length(em_GFP_OD(:,1))/8
      if ii>=6
        subplot(1,5,ii-5)
    else
        subplot(1,5,ii)
      end
    hold on 
    plot(time_hr(1:Tfp),em_GFP_OD(ii*4-3:ii*4,1:Tfp))
    if ii==1
        ylabel('Emission/OD')
    end
 end

%%
%           	****************************************
%                                 mVenus
%           	****************************************
Tf=82
figure('units','normalized','outerposition',[0 0 1 1])
for ii=1:length(OD_mVe_mean(:,1))/2
    Fitv_mVe(ii,1) = OD_mVe_mean(ii,1);
    [Fitv_mVe(ii,2:4)]=growthrate(time_hr(1:Tf),OD_mVe_mean(ii,1:Tf), [0.96,1,0.2],Fitv_mVe(ii,1)); % Fit values mu_max, OD_max, q

    OD_mVe_Fit (ii,:)          = Fitv_mVe(ii,3)*Fitv_mVe(ii,1).*(Fitv_mVe(ii,4).*exp(Fitv_mVe(ii,2)*time_hr)+1)...
                  ./(Fitv_mVe(ii,1)*Fitv_mVe(ii,4).*(exp(Fitv_mVe(ii,2)*time_hr)-1)+Fitv_mVe(ii,3)*(Fitv_mVe(ii,4)+1));    % Fitted N(t)
    mu_mVe_fit(ii,:)= diff(log(OD_mVe_Fit(ii,:)))./diff(time_hr);
   
  
    subplot(1,3,1)
    hold on
    semilogy(time_hr,OD_mVe_mean(ii,:))
    plot(time_hr(1:Tf),OD_mVe_Fit(ii,1:Tf),'+')
    z_mVe(ii,:) = Fitv_mVe(ii,1)/(Fitv_mVe(ii,3)-Fitv_mVe(ii,1))*(1+Fitv_mVe(ii,4)*exp(Fitv_mVe(ii,2)*time_hr))/(1+Fitv_mVe(ii,4));
    mut_mVe(ii,:) = Fitv_mVe(ii,4)./(Fitv_mVe(ii,4)+exp(-Fitv_mVe(ii,2).*time_hr)).*Fitv_mVe(ii,2).*(1-(1-1./(z_mVe(ii,:)+1)));
    
    subplot(1,3,2)
    hold on
    plot(time_hr,em_mVe_mean(ii,:))
    
    subplot(1,3,3)
    hold on
    plot(time_hr,em_mVe_OD(ii*4-3:ii*4,:))
    
end
subplot(1,3,3)
plot(time_hr,mut_mVe)

%%
%           	****************************************
%                                mCerulean
%           	****************************************
figure('units','normalized','outerposition',[0 0 1 1])

for ii=1:length(OD_mCe_mean(:,1))
    Fitv_mCe(ii,1) = OD_mCe_mean(ii,1);
    [Fitv_mCe(ii,2:4)]=growthrate(time_hr(1:Tf),OD_mCe_mean(ii,1:Tf), [0.96,1,0.2],Fitv_mCe(ii,1)); % Fit values mu_max, OD_max, q

    OD_mCe_Fit (ii,:)          = Fitv_mCe(ii,3)*Fitv_mCe(ii,1).*(Fitv_mCe(ii,4).*exp(Fitv_mCe(ii,2)*time_hr)+1)...
                  ./(Fitv_mCe(ii,1)*Fitv_mCe(ii,4).*(exp(Fitv_mCe(ii,2)*time_hr)-1)+Fitv_mCe(ii,3)*(Fitv_mCe(ii,4)+1));    % Fitted N(t)
    mu_mCe_fit(ii,:)= diff(log(OD_mCe_Fit(ii,:)))./diff(time_hr);
   

    subplot(1,3,1)
          hold on
    semilogy(time_hr,OD_mCe_mean(ii,:))

    plot(time_hr(1:Tf),OD_mCe_Fit(ii,1:Tf),'+')
    hold off
     z_mCe(ii,:) = Fitv_mCe(ii,1)/(Fitv_mCe(ii,3)-Fitv_mCe(ii,1))*(1+Fitv_mCe(ii,4)*exp(Fitv_mCe(ii,2)*time_hr))/(1+Fitv_mCe(ii,4));
    mut_mCe(ii,:) = Fitv_mCe(ii,4)./(Fitv_mCe(ii,4)+exp(-Fitv_mCe(ii,2).*time_hr)).*Fitv_mCe(ii,2).*(1-(1-1./(z_mCe(ii,:)+1)));
    
        subplot(1,3,2)
    hold on
    plot(time_hr,em_mCe_mean(ii,:))
    
    subplot(1,3,3)
    hold on
    plot(time_hr,em_mCe_OD(ii*4-3:ii*4,:))
end
% subplot(2,2,4)
% plot(time_hr,mut_mCe)
% 
% temp_OD_Ce=OD_mCe_mean(1,40:60);
% temt = time_hr(40:60);

%%

% *************************************************************************
%                           Emission/OD
% *************************************************************************


%% calculate average
em_GFP_OD_av = zeros(size(em_GFP_OD,1)/4,size(em_GFP_OD,2));
for i = 1:size(em_GFP_OD,2)
    for a = 1:size(em_GFP_OD,1)/4
        em_GFP_OD_av(a,i) = nanmean(em_GFP_OD(a*4-3:a*4,i));
    end
end

em_mVe_OD_av = zeros(size(em_mVe_OD,1)/4,size(em_mVe_OD,2));
for i = 1:size(em_mVe_OD,2)
    for a = 1:size(em_mVe_OD,1)/4
        em_mVe_OD_av(a,i) = nanmean(em_mVe_OD(a*4-3:a*4,i));
    end
end

em_mCe_OD_av = zeros(size(em_mCe_OD,1)/4,size(em_mCe_OD,2));
for i = 1:size(em_mCe_OD,2)
    for a = 1:size(em_mCe_OD,1)/4
        em_mCe_OD_av(a,i) = nanmean(em_mCe_OD(a*4-3:a*4,i));
    end
end
Tfp=82
 figure('units','normalized','outerposition',[0 0 1 1])
 for ii=1:length(em_GFP_OD(:,1))/4
      if ii>=6
        subplot(1,5,ii-5)
    else
        subplot(1,5,ii)
      end
    hold on 
    plot(time_hr(1:Tfp),em_GFP_OD_av(ii,1:Tfp))
    if ii==1
        ylabel('Emission/OD')
    end
 end

%% plot emission/OD GFP diluted samples
time_hr = time./3600;
figure()
for i = 1:size(em_GFP_OD_av,1)/2
    plot(time_hr,em_GFP_OD_av(i,:))
    hold on
end

hold off
xlabel('time(s)')
ylabel('emission/OD600')
legend('J23100','J23108','J23105','J23117','J23113')
title('GFP 10x diluted')

%% plot emission/OD GFP undiluted samples 
figure()
for i = size(em_GFP_OD_av,1)/2+1:size(em_GFP_OD_av,1)
    plot(time_hr,em_GFP_OD_av(i,:))
    hold on
end

hold off
xlabel('time(s)')
ylabel('emission/OD600')
legend('J23100','J23108','J23105','J23117','J23113')
title('GFP undiluted')
%% plot emission/OD mVenus
figure()
plot(time_hr,em_mVe_OD_av,'x')
xlabel('time(s)')
ylabel('emission/OD600')
legend('mVenus undiluted', 'mVenus 10x diluted')
title('mVenus')

%% plot emission/OD mCerulean
figure()
plot(time_hr,em_mCe_OD_av,'x')
xlabel('time(s)')
ylabel('emission/OD600')
legend('mCerulean')
title('mCerulean')

%%

% *************************************************************************
%                           GFP Calibration curve

% *************************************************************************
GFP0=98e-6;              % [Mol/L] Concentration GFP
V = 100e-6 % [L] volume 100ul
C = [ GFP0/100, GFP0/200, GFP0/400, GFP0/800, GFP0/1600]*V  % [mol] of eGFP
F0=[223*ones(5,1), 244*ones(5,1)]                     % blanck RFU
Fm = [47558	47539;22291	22210;8817	8907;3496	3766;1384	1505];%;688	762]; % GFP fluorescence measurements RFU
F=2*(Fm-F0)/0.63% 2* because gain is 50 instead of 100
error=std(F');
F = mean(F');
[r, FtoC, b]=regression(C ,F)
figure(3)
p1=plot(C*1e9,FtoC.*C+b)
hold on 
% plot(C,Fm)
p2=errorbar(C*1e9,F,error,'k.','LineWidth',1)
xlabel('GFP (nmol)')
ax = gca;
p1.LineWidth =2; 
p2.LineWidth =1; 
ax.LineWidth = 2;
ax.FontSize = 18;
hold off
title('Calibration curve EGFP')
ylabel('Fluorescence (a.u.)')


%%

% *************************************************************************
%                   DETERMINE CONCENTRATION OF FLUOROPHORES

% *************************************************************************
% close all
figure(1)
V=100e-6;                                   %[L] Volume of platereader samples
Celln = OD_GFP_mean*8e8*V*1e3;             %  1OD=8e8 cells/ml*Volume*ml/L
F1=em_GFP_mean./Celln;                      % [RFU/cell] 
for ii=1:5
 
    F1av(ii,:) =nanmean([F1(ii,:);F1(ii+5,:)]) ;
end
figure('units','normalized','outerposition',[0 0 1 1])
subplot(1,2,1)
    hold on 
    p1=plot(time_hr,em_GFP_mean(1:5,:),'.-', 'MarkerSize',15)
        ax = gca;
    ax.LineWidth = 2;
	ax.FontSize = 18;
    xlabel('time(h)')
    ylabel('Fluorescence (a.u.)')
    subplot(1,2,2)
plot(time_hr,F1(1:5,:),'.-', 'MarkerSize',15)
legend(promoters)

ax = gca;
ax.LineWidth = 2;
ax.FontSize = 20;
xlabel('time (h)')
ylabel('Fluorescence/OD (a.u.)')
hold off
 
%%
CF = (F1)/FtoC;
RB_GFPmut3b = 21*0.64;% mol inside a cell
Conc_GFPmeasured = CF/1e-15*1e3/RB_GFPmut3b; % mM EGFP in cell
p1=plot(time_hr,1/0.6*1/0.73*(Conc_GFPmeasured(1:10,:)'), 'LineWidth',2)
 promoters = ['J23100';'J23108';'J23105';'J23117';'J23113'];
 legend(promoters)
% title('mM inside cell')
ax = gca;
ax.LineWidth = 2;
ax.FontSize = 20;
xlabel('time [h]')
ylabel('GFP concentration [mM]')
hold off
max(1/0.6*1/0.73*(Conc_GFPmeasured(1:5,:)'))
% plot(OD_GFP_mean'*8e8*100e-6)
%%
% 
Celln_mVe = OD_mVe_mean*7e8*V*1e3;             %  1OD=8e8 cells/ml*Volume*ml/L
F2=em_mVe_mean./Celln_mVe;                     % [RFU/cell] 
CF2 = (F2)/FtoC;
RB_mVe = 1.56;                                  % Relative brightness
EMEX_mVe= 1;                                    % Relative emission and relative excitation
Conc_mVemeasured = CF2/1e-15*1e3/RB_mVe*1/(EMEX_mVe); % mM EGFP in cell
figure(3)
plot((1/0.6*Conc_mVemeasured'))
co=max(1/0.6*Conc_mVemeasured')

% 
Celln_mCe = OD_mCe_mean*7e8*V*1e3;              %  1OD=8e8 cells/ml*Volume*ml/L
F3=em_mCe_mean./Celln_mCe;                      % [RFU/cell] 
CF3 = (F3)/FtoC;
EMEX_mCe= 0.6;                                  % Relative brightness
RB_mCe = 0.79;                                  % Relative emission and relative excitation  
Conc_mCemeasured = CF3/1e-15*1e3/RB_mCe*1/EMEX_mCe; % mM EGFP in cell
figure(4)
plot((Conc_mCemeasured'))

conc= max(Conc_mCemeasured')




